#ifndef RAWMICROSLICEHEADERV1_H
#define RAWMICROSLICEHEADERV1_H
#include "DAQDataFormats/RawMicroSliceHeaderV0.h"
#include "DAQDataFormats/Macros.h"
#include "DAQDataFormats/BitFields.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroSliceHeader
#define  CURRENT_CLASS_VERSION        1
#define  CURRENT_FIELDS_SUB_NAMESPACE rawmuhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
     namespace  VERSION_NAMESPACE {
        namespace CURRENT_FIELDS_SUB_NAMESPACE {

            enum MicroSliceHeaderMASKS{
                    MASK_Status = 0x3FC00000,///< FEB Status bits
            };
            enum MicroSliceHeaderWORDS {
                    WORD_Status = 0,///< DP bit
            };

            DEFINE_SHIFT_FROM_MASK(Status)
        };// end of namespace CURRENT_FIELDS_SUB_NAMESPACE


    class RawMicroSliceHeader: public PREVIOUS_VERSION_CLASS_NAME {
    
        public:
            RawMicroSliceHeader (const version_t);
            RawMicroSliceHeader (const RawMicroSliceHeader&);
            ~RawMicroSliceHeader(); ///< Destructor

            using    PREVIOUS_VERSION_CLASS_NAME::print;
            void     print (std::ostream& os=std::cout) const;

            IMPLEMENT_GET(Status, uint32_t)
            IMPLEMENT_SET(Status, uint32_t)
    };// end of RawMicroSliceHeader
}} // END NAMESPCE 

#endif /* RAWMICROSLICEHEADERV1_H */
