#ifndef _DBUTILS_DAQCONFIG_FEBPULSERPARAMETERSET_H
#define _DBUTILS_DAQCONFIG_FEBPULSERPARAMETERSET_H

#include <stdint.h>

namespace dbutils {
namespace daqconfig {

/**
 * Simple container class for a set of FEB pulser parameter values.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2011/02/01 22:19:34 $
 */

class FEBPulserParameterSet {

 public:

    // ********************
    // *** Constructors ***
    // ********************

    FEBPulserParameterSet(int16_t pulserEnable, int32_t pulserPeriod,
                          int32_t pulserWidth);

    // *****************
    // *** Accessors ***
    // *****************

    int16_t getPulserEnable() {return _pulserEnable;}
    int32_t getPulserPeriod() {return _pulserPeriod;}
    int32_t getPulserWidth() {return _pulserWidth;}

    // *****************
    // *** Operators ***
    // *****************

    bool operator==(const FEBPulserParameterSet& other);
    bool operator!=(const FEBPulserParameterSet& other);

 private:

    int16_t _pulserEnable;
    int32_t _pulserPeriod;
    int32_t _pulserWidth;
};

};  // end of namespace daqconfig
};  // end of namespace dbutils

#endif
