#ifndef _NOVADAQ_TIMEDCACHEPOLICY_H
#define _NOVADAQ_TIMEDCACHEPOLICY_H

#include <NovaDAQUtilities/CachePolicy.h>
#include <time.h>

namespace novadaq {

/**
 * A cache expiration policy based on a time interval.
 *
 * @author Kurt Biery
 * @version $Revision: 1.2 $ $Date: 2010/05/04 19:14:33 $
 */

class TimedCachePolicy : public novadaq::CachePolicy {

 public:

    explicit TimedCachePolicy(int timeoutInMinutes);

    ~TimedCachePolicy() {};

 protected:

    void _markAsUpdated();

    bool _checkIfExpired();

 private:

    time_t _timeoutInSeconds;
    time_t _lastUpdateTime;

};

};  // end of namespace novadaq

#endif
