#include "DAQDataFormats/RawMicroBlock.h"
#include "DAQDataFormats/DataFormatException.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroBlock
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE microblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{

//------------------------------------------------------------------------------
// Default constructor
RawMicroBlock::RawMicroBlock(const version_t version, const uint32_t size):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    reserveInternalBuffer(size);
    defaultConstructorFloatingSize();
}
//------------------------------------------------------------------------------
RawMicroBlock::RawMicroBlock(const RawMicroBlock& copy_in):
    PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    lastOperationsInDeepCopy(copy_in);
}

//------------------------------------------------------------------------------
RawMicroBlock::RawMicroBlock(const void* buffer, const version_t version, const uint32_t /*size*/):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    copy(buffer);
}
//------------------------------------------------------------------------------
// Destructor
RawMicroBlock::~RawMicroBlock() { }

/// All binding routines
#define STANDARD_ROUTINES                           \
            BIND_STADARD_FUNCTIONS                  

#include "DAQDataFormats/setFunctionPointers_template.inc"



} // end of namespace