#include "DAQDataFormats/RawMicroSliceHeaderV1.h"
#include <boost/format.hpp>

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroSliceHeader
#define  CURRENT_CLASS_VERSION        1
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{
namespace VERSION_NAMESPACE{

//------------------------Constructors------------------------------------------
RawMicroSliceHeader::RawMicroSliceHeader(const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{}

//------------------------------------------------------------------------------
RawMicroSliceHeader::RawMicroSliceHeader(const RawMicroSliceHeader& copyin):
     PREVIOUS_VERSION_CLASS_NAME(copyin)
{}

//------------------------Destructor--------------------------------------------
RawMicroSliceHeader::~RawMicroSliceHeader() { }

//------------------------------------------------------------------------------
// Printing method
void RawMicroSliceHeader::print(std::ostream& os) const
{
    /// Just in case
    if(_version == 0) return version0::RawMicroSliceHeader::print(os);

    os<<boost::format("MicroSlice Header: Version=%d DP=%d SIM=%d Status=%d Timeout=%d, LBC=%d\n")
	   % getVersion()
	   % getDataPresent()
	   % getMonteCarloFlag()
	   % EXECUTE_FUNCTION(getStatus)()
	   % getTimeout()
	   % getByteCount()
           ;

            printBuffer(os);
            os<<"RAW(binary):";
            printWord(0,true, os);
            os<<std::endl;
}// end of print1

}}// end of daqdataformats::version0