#include <DatabaseUtils/DAQConfig/DBColumnUtils.h>
#include <DatabaseUtils/DAQConfig/NamedConfigUtils.h>

namespace dbutils {
namespace daqconfig {

bool DBColumnUtils::
isInfrastructureColumn(const std::string& columnName)
{
    if (columnName == NamedConfigUtils::ID_COLUMN_NAME) {return true;}
    if (columnName == NamedConfigUtils::INSERTTIME_COLUMN_NAME) {return true;}
    if (columnName == NamedConfigUtils::INSERTUSER_COLUMN_NAME) {return true;}
    if (columnName == NamedConfigUtils::UPDATETIME_COLUMN_NAME) {return true;}
    if (columnName == NamedConfigUtils::UPDATEUSER_COLUMN_NAME) {return true;}

    return false;
}

bool DBColumnUtils::
isSubsystemConfigReferenceColumn(const std::string& columnName)
{
    if (columnName == NamedConfigUtils::SUBSYSCFGID_COLUMN_NAME) {return true;}

    return false;
}

bool DBColumnUtils::
isNamedConfigReferenceColumn(const std::string& columnName)
{
    if (columnName == NamedConfigUtils::SUBSYSCFGID_COLUMN_NAME) {return true;}
    if (columnName == NamedConfigUtils::GLOBALCFGID_COLUMN_NAME) {return true;}
    if (columnName == NamedConfigUtils::PARENTID_COLUMN_NAME) {return true;}

    return false;
}

};  // end of namespace daqconfig
};  // end of namespace dbutils
